
#include <hmg.ch>
#include "hfcl.ch"
#include "NumFactura.prg"
#include "Print_TxT.prg"
#include "Print_PdF.prg"
#include "Viewx.prg"

Function Main()

*----------------------------------------*
* (c) Mustafa Lpez  mustalopez@gmail.com
*----------------------------------------*

  REQUEST DBFCDX , DBFFPT , DBFDBT
  RDDSETDEFAULT( "DBFCDX" )

  SET CODEPAGE TO SPANISH 
*---------------------------------------------------------------------*
  SET DELETE ON
  SET DECIMALS TO 2
  SET FIXED ON
  SET CENTURY ON
  SET DATE FRENCH
  SET DATE FORMAT TO "dd/mm/yyyy"
  SET ESCAPE ON
  SET NAVIGATION EXTENDED
  SET BROWSESYNC OFF
  SET TOOLTIPSTYLE BALLOON

*----------------------------------------------------------------------*

 PRIVATE  cNombre ,  numero ,  cNUmero ,     horaS , aChecbo , ficherox 
 PRIVATE   nValor ,  ComasX ,  nValorX ,  nValorXF ,    pext ,  provax
 PRIVATE  AnValor , AComasX , AnValorX , AnValorXF ,   Apext , Aprovax
 PRIVATE  BnValor , BComasX , BnValorX , BnValorXF ,   Bpext , Bprovax
 PRIVATE  CnValor , CComasX , CnValorX , CnValorXF ,   Cpext , Cprovax
 PRIVATE  DnValor , DComasX , DnValorX , DnValorXF ,   Dpext , Dprovax

*---------------------------------------------------------------------*

  DEFINE WINDOW main                              ;
       AT 000,000                                 ;
       WIDTH  320 HEIGHT 410                      ; 
       ICON "Logo"                                ;  
       TITLE 'HMG HPDF PRINT Sample Factura -> ' ;
       NOSIZE NOMINIMIZE NOMAXIMIZE   TOPMOST     ;
       MAIN                                       ;
       ON INIT OpenTables()                       ;
       ON PAINT Proc_ON_PAINT()                   ;  // <------- Color Gris de Fondo Windows
       ON INTERACTIVECLOSE ( MsgStop('Not Allowed', 'Attention !!!') , .F. )                                       

       ON KEY ESCAPE ACTION FinalProgram()       

    @ 044,073 CHECKBOX  Check_1 CAPTION ""  WIDTH 14 HEIGHT 14 
                    
    @ 043,096 LABEL Label_2 VALUE 'Fichero Respaldo TxT ?'WIDTH 140 HEIGHT 15 ;
                            FONT "Arial" SIZE 10 BOLD ITALIC BACKCOLOR { 000,213,000}  ;
                            FONTCOLOR {238,253,067}    
                   
    DEFINE BUTTON Button_01
        ROW    079
        COL    070  
        WIDTH  165
        HEIGHT 049   //055
        CAPTION 'Factura Pdf'
        ACTION pdf_create() 
        FONTNAME "Arial"
        FONTSIZE 9
        TOOLTIP "Acept"
        FONTBOLD .T.
        FONTITALIC .T.
        FONTUNDERLINE .F.
        FONTSTRIKEOUT .F.
        ONGOTFOCUS Nil
        ONLOSTFOCUS Nil
        HELPID Nil
        FLAT .F.
        TABSTOP .T.
        VISIBLE .T.
        TRANSPARENT .F.
        MULTILINE .F.
        PICTURE "resource\Imagen01.bmp"
        PICTALIGNMENT LEFT
    END BUTTON

    DEFINE BUTTON Button_02
        ROW    139  
        COL    070  
        WIDTH  165
        HEIGHT 049  //055
        CAPTION 'Tools'
        ACTION NumFactura() 
        FONTNAME "Arial"
        FONTSIZE 9
        TOOLTIP "Tools"
        FONTBOLD .T.
        FONTITALIC .T.
        FONTUNDERLINE .F.
        FONTSTRIKEOUT .F.
        ONGOTFOCUS Nil
        ONLOSTFOCUS Nil
        HELPID Nil
        FLAT .F.
        TABSTOP .T.
        VISIBLE .T.
        TRANSPARENT .F.
        MULTILINE .F.
        PICTURE "resource\Imagen04.bmp"
        PICTALIGNMENT LEFT
    END BUTTON
      
    DEFINE BUTTON Button_03
        ROW    197
        COL    070  
        WIDTH  165
        HEIGHT 049   //055
        CAPTION 'View Database'
        ACTION ViewFacty() 
        FONTNAME "Arial"
        FONTSIZE 9
        TOOLTIP "View"
        FONTBOLD .T.
        FONTITALIC .T.
        FONTUNDERLINE .F.
        FONTSTRIKEOUT .F.
        ONGOTFOCUS Nil
        ONLOSTFOCUS Nil
        HELPID Nil
        FLAT .F.
        TABSTOP .T.
        VISIBLE .T.
        TRANSPARENT .F.
        MULTILINE .F.
        PICTURE "resource\Imagen02.bmp"
        PICTALIGNMENT LEFT
    END BUTTON
        
    DEFINE BUTTON Button_04
        ROW    255 //230  
        COL    070 
        WIDTH  165
        HEIGHT 049  //055
        CAPTION 'Exit'
        ACTION FinalProgram()            
        FONTNAME "Arial"
        FONTSIZE 9
        TOOLTIP "Exit"
        FONTBOLD .T.
        FONTITALIC .T.
        FONTUNDERLINE .F.
        FONTSTRIKEOUT .F.
        ONGOTFOCUS Nil
        ONLOSTFOCUS Nil
        HELPID Nil
        FLAT .F.
        TABSTOP .T.
        VISIBLE .T.
        TRANSPARENT .F.
        MULTILINE .F.
        PICTURE "resource\Imagen03.bmp"
        PICTALIGNMENT LEFT
    END BUTTON

  main.Check_1.value:= .T.

  end window

       SETWINDOWCURSOR ( main.Button_01.Handle, "resource\SmoothHand.cur")

   main.center
   main.activate
 
Return

*------------------------------------------*
  FUNCTION FinalProgram()
*------------------------------------------*

 IF MsgYesNo("Do you want to finish the program ?","Atention !!!") = .T.
       CLOSE DATABASES
       main.Release
    Return .T.
 EndIf

*---------------------------------------------------*
 FUNCTION OpenTables()
*---------------------------------------------------*

   SELECT 1
   USE MESES
   SELECT 2
   USE VENTAS new

Return .T.

*---------------------------------------*
FUNCTION  FileSecury()
*---------------------------------------*

 *---------------------------------------------------------*
 *------------- Fichero Copia Seguridad -------------------*
 *---------------------------------------------------------*

   ficherox = "Factura"+"_"+cNumero +".pdf"

   USE ventas
   numb   = NUM_CLI
   rsoc   = R_SOCIAL

   CLOSE DATABASES
   USE segury
   APPEND FROM MESES

   REPLACE NUM_CLI  WITH numb
   REPLACE R_SOCIAL WITH rsoc
   REPLACE NOM_FICH WITH ficherox
   REPLACE SUMA     WITH TOT
   REPLACE IVA      WITH Ivax
   REPLACE TOTAL    WITH Totis
   CLOSE DATABASES

*------------------------------------------------------------*
 
   IF msgYesNo( "Desea abrir el archivo generado por la impresion?","Atention!!!" )
                 CLOSE DATABASES
                 View_Pdf()
           *     Execute File cNombre  //  <------------- (opcional)
   ENDIF

*------------------------------------------------------------*

   aChecbo  := ( IIF( main.Check_1.Value,"True","False") )
   
   IF aChecbo = "True" 
            GeneraTXT()
            RETURN Nil

   ENDIF

RETURN Nil


*---------------------------------------*
FUNCTION  View_Pdf()
*---------------------------------------*

   DEFINE WINDOW Form_1       ;
      AT 0,0                  ;
      WIDTH  860              ;  
      HEIGHT 740              ;
      ICON "Logo"             ;  
      TITLE ficherox          ;
      CHILD NOMAXIMIZE NOMINIMIZE NOSIZE      
      
      ON KEY ESCAPE ACTION  Form_1.Release   

        DEFINE TIMER Timer_2 ;
               INTERVAL 100 ;
               ACTION { || thisWindow.Row := 010, thisWindow.Col := 240 }  

        DEFINE MAIN MENU
             POPUP 'E&xit'
             SEPARATOR      
             ITEM  'E&xit ...' ACTION Form_1.Release   IMAGE 'Resource\Exit.Bmp'     
             END POPUP
        END MENU  


   @ 10,17 ACTIVEX Test             ;
             PARENT Form_1          ;
             WIDTH  820             ; 
             HEIGHT 664             ;   
             PROGID "AcroPDF.PDF.1"   

  Form_1.Test.Object:src := HB_CurDrive() + ':\' + Curdir() + '\' +  "Facturas_PdF\" +  ficherox    
* Form_1.Test.Object:src := GetCurrentFolder() + '\Facturas_PdF\' +  ficherox                     // <------ Mismo Resultado

  END WINDOW

      SETWINDOWCURSOR ( Form_1.Test.Handle, "Resource\SmoothHand.cur")  

   Form_1.Test.SetFocus  

   Form_1.center
   Activate Window Form_1

   RETURN NIL

*-----------------------------------------------------------*
 FUNCTION Proc_ON_PAINT()  //  -> Courtesy of Javier Tovar
*-----------------------------------------------------------*

LOCAL hDC, BTstruct

hBitmap := BT_BitmapRelease() 

   hDC := BT_CreateDC ("main", BT_HDC_INVALIDCLIENTAREA, @BTstruct)
          BT_DrawGradientFillVertical (hDC, 0, 0, BT_ClientAreaWidth("main"), BT_ClientAreaHeight("main"), GREEN, BLACK)
          BT_DrawBitmap (hDC, 0, 0, 400, 200, BT_COPY, hBitmap)
          BT_DeleteDC (BTstruct)
RETURN

*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*

















   